=== debian/changelog ===
loop-aes (3.3a-2) unstable; urgency=low

  * Orphaning the package (#614808)
  * Set maintainer to Debian QA Group

 -- Max Vozeler <xam@debian.org>  Wed, 23 Feb 2011 17:52:28 +0100

loop-aes (3.3a-1) unstable; urgency=low

  * New upstream release
  * Switch to 3.0 (quilt) format for upstream .tar.bz2
  * Update Standards-Version to 3.8.4 (no changes)

 -- Max Vozeler <xam@debian.org>  Mon, 29 Mar 2010 19:04:20 +0200

loop-aes (3.2h-1) unstable; urgency=low

  * New upstream release
    - Fixes build with 2.6.32 (closes: #560214)
  * Update Standards-Version to 3.8.3 (no changes)
  * Add copyright info for loop-aes-keygen (closes: #492123)

 -- Max Vozeler <xam@debian.org>  Sat, 12 Dec 2009 14:37:51 +0100

loop-aes (3.2g-1) unstable; urgency=low

  * New upstream release
  * Set section to 'kernel' 
  * Update Standards-Version to 3.8.1 (no changes)
  * Update to debhelper level 7

 -- Max Vozeler <xam@debian.org>  Fri, 03 Jul 2009 20:42:10 +0200

loop-aes (3.2f-1) unstable; urgency=low

  * New upstream release
    - Fixes build with 2.6.29 (closes: #521348)
  * debian/copyright: Update years

 -- Max Vozeler <xam@debian.org>  Sun, 29 Mar 2009 14:02:13 +0200

loop-aes (3.2e-1) unstable; urgency=low

  * New upstream release
   - Fixes build with 2.6.28 (closes: #510037)
  * Bump Standards-Version to 3.8.0 (no changes)
  * Remove spurious build dependency on module-assistant 

 -- Max Vozeler <xam@debian.org>  Sun, 22 Feb 2009 15:37:24 +0100

loop-aes (3.2c-2) unstable; urgency=low

  * loop-aes-testsuite: Add depends on make

 -- Max Vozeler <xam@debian.org>  Fri, 14 Mar 2008 16:26:30 +0100

loop-aes (3.2c-1) unstable; urgency=low

  * New upstream release 

 -- Max Vozeler <xam@debian.org>  Sun, 09 Mar 2008 01:42:39 +0100

loop-aes (3.2b-5) unstable; urgency=low

  * Restore debian/source/control (closes: #465385)

 -- Max Vozeler <xam@debian.org>  Tue, 12 Feb 2008 09:16:17 +0100

loop-aes (3.2b-4) unstable; urgency=low

  * Back to being a pure -source package. Modules
    are now included in linux-modules-extra-2.6.

 -- Max Vozeler <xam@debian.org>  Fri, 08 Feb 2008 09:09:09 +0100

loop-aes (3.2b-3) unstable; urgency=low

  * Include Makefile-2.6 in -source so it can be
    used by linux-modules-extra-2.6.

 -- Max Vozeler <xam@debian.org>  Sun, 20 Jan 2008 12:14:42 +0100

loop-aes (3.2b-2) unstable; urgency=low

  * Update modules to 2.6.23-1
  * Adapt gencontrol to linux-support-2.6.23-1
  * Bump Standards-Version to 3.7.3 (no changes)

 -- Max Vozeler <xam@debian.org>  Sat, 08 Dec 2007 21:11:33 +0100

loop-aes (3.2b-1) unstable; urgency=low

  * New upstream release
  * Update modules to 2.6.22-3

 -- Max Vozeler <xam@debian.org>  Sat, 27 Oct 2007 13:48:30 +0200

loop-aes (3.2a-5) unstable; urgency=low

  * Update modules to 2.6.22-2 
  * Use explicit f argument to tar when creating 
    loop-aes.tar.bz2

 -- Max Vozeler <xam@debian.org>  Wed, 05 Sep 2007 23:55:22 +0200

loop-aes (3.2a-4) unstable; urgency=low

  * Update to 2.6.22-1
  * Adapt gencontrol to linux-support-2.6.22-1
  * Make loop-aes-modules-2.6-$(flavour) depend on
    linux-latest-modules-$(KVERS)

 -- Max Vozeler <xam@debian.org>  Sun, 12 Aug 2007 13:53:54 +0200

loop-aes (3.2a-3) unstable; urgency=low

  * Update modules to 2.6.21-2 

 -- Max Vozeler <xam@debian.org>  Wed, 27 Jun 2007 00:28:12 +0200

loop-aes (3.2a-2) unstable; urgency=low

  * Update modules to 2.6.21-1
  * Update years in debian/copyright and adapt to ciphers
    merged in v3.2a.

 -- Max Vozeler <xam@debian.org>  Wed, 23 May 2007 20:59:01 +0200

loop-aes (3.2a-1) unstable; urgency=low

  * New upstream release
  * Finally use unchanged upstream tarball :-)
  * Remove obsolete script debian/get-orig-source
  * Remove README.ciphers, changelog.ciphers
  * Use upstream Makefile in debian/rules.real
  * Adapt debian/rules.real, debian/source/rules for changed paths
  * Update documentation on ciphers
  * Update README.Debian on now obsolete GnuPG patch, 
    thanks to Torbjörn Wictorin. (Closes: #423395)

 -- Max Vozeler <xam@debian.org>  Thu, 17 May 2007 20:11:54 +0200

loop-aes (3.1f-2) unstable; urgency=low

  * Update modules to 2.6.20-1
  * Enable support for VIA padlock xcrypt instruction
  * Adapt gencontrol to linux-support-2.6.20-1

 -- Max Vozeler <xam@debian.org>  Sat, 21 Apr 2007 20:22:06 +0200

loop-aes (3.1f-1) experimental; urgency=low

  * New upstream release (Closes: #403974)
  * Make module packages depend on linux-modules-$KVERS 
    instead of linux-image-$KVERS. (Closes: #409205)

 -- Max Vozeler <xam@debian.org>  Sat, 24 Feb 2007 22:17:56 +0100

loop-aes (3.1d-13) unstable; urgency=low

  * Adapt bin/gencontrol.py to cope with .dsfg version
  * Update modules to 2.6.18-4 

 -- Max Vozeler <xam@debian.org>  Sun, 28 Jan 2007 12:32:15 +0100

loop-aes (3.1d-12) unstable; urgency=low

  * Update modules to 2.6.18-3 
  * Provide usage information for loop-aes-runtests
  * Reenable keyscrub by default

 -- Max Vozeler <xam@debian.org>  Fri, 24 Nov 2006 20:11:06 +0100

loop-aes (3.1d-11) unstable; urgency=low

  * Update modules to 2.6.18-2
  * Add manpage for loop-aes-runtests
  * Make loop-aes-runtest quiet by default, add -v
  * Set maintainer to Debian Loop-AES Team

 -- Max Vozeler <xam@debian.org>  Thu,  9 Nov 2006 19:13:31 +0100

loop-aes (3.1d-10) unstable; urgency=low

  * Update the package name for dpkg-divert. (Closes: #392841)
  * Drop conflicts with loop-aes-ciphers-$KVERS

 -- Max Vozeler <xam@debian.org>  Sun, 15 Oct 2006 17:35:09 +0200

loop-aes (3.1d-9) unstable; urgency=low

  * Update to 2.6.18-1
  * Respect modules: False in arch defines. (Closes: #390554)
  * Use a hardlink for loop-aes.ko -> loop.ko

 -- Max Vozeler <xam@debian.org>  Sat,  7 Oct 2006 17:55:18 +0200

loop-aes (3.1d-8) unstable; urgency=low

  * Revert back to 2.6.17-2 for upload to unstable

 -- Max Vozeler <xam@debian.org>  Sun,  1 Oct 2006 18:59:30 +0200

loop-aes (3.1d-7) experimental; urgency=low

  * Update to 2.6.18-1

