=== debian/control ===
Source: loop-aes
Section: kernel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 7), bzip2, fakeroot

Package: loop-aes-source
Architecture: all
Depends: build-essential, debhelper (>= 7), module-assistant, bzip2
Recommends: loop-aes-testsuite
Description: source for loop-AES encryption modules
 This package contains source code of the loop-AES loadable kernel
 modules for Linux 2.0 - 2.6. It can be used with module-assistant,
 make-kpkg or stand-alone to build loop-AES module packages.
 .
 loop-AES can be used to encrypt disk partitions, removable media, 
 swap space and other devices. It provides measures to strengthen 
 the encryption: Passphrase seeds, multiple hash iterations, MD5 IV
 and use of alternating encryption keys.
 .
 Encryption keys can be stored in a GnuPG-encrypted keyfile, which
 allows the passphrase to be changed without re-encryption. Keyfiles
 can also be encrypted asymmetrically for multi-user access.
 . 
 This package includes the cipher modules blowfish, twofish and 
 serpent in addition to the default cipher (AES).
 .
 Modules compiled from this package require mount utils with
 support for loop-AES to work correctly. Such utils are provided
 in the package 'loop-aes-utils'.

Package: loop-aes-testsuite
Architecture: all
Depends: make
Provides: loop-aes-testsuite-v3
Description: test suite for loop-AES encryption modules
 This package provides scripts for testing the loop-AES encryption
 kernel modules.
