=== debian/watch ===
version=2
http://loop-aes.sourceforge.net/loop-AES/loop-AES-v(.*).tar.bz2
